//	+-----------------------------------+
//	|		HL2 Weapons Pack			|
//	|		by Zapk & Aware14			|
//	+-----------------------------------+
//	|		AR2.cs						|
//	+-----------------------------------+

//audio
datablock AudioProfile(AR2fireSound)
{
   filename    = "./AR2_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(AR2FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0 0.8 0.9";
	colors[1]     = "0.0 0 0.1 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(AR2FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "AR2FlashParticle";

   uiName = "AR2 Flash";
};

datablock ParticleData(AR2TrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 75;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.0 0.1 0.8 1";
	colors[1]	= "0.0 0.1 0.3 0.4";
	sizes[0]	= 0.07;
	sizes[1]	= 0.15;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(AR2TrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = AR2TrailParticle;

   useEmitterColors = true;
   uiName = "";
};

AddDamageType("AR2",   '<bitmap:Add-Ons/Weapon_HL2/CI_AR2> %1',    '%2 <bitmap:Add-Ons/Weapon_HL2/CI_AR2> %1',0.5,1);
datablock ProjectileData(AR2Projectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::AR2;
   radiusDamageType    = $DamageType::AR2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;  
   brickExplosionMaxVolumeFloating = 1; 

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;
   particleEmitter     = AR2TrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};

datablock ItemData(AR2Item)
{
	category = "Weapon"; 
	className = "Weapon";

	shapeFile = "./AR2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "AR2";
	iconName = "./Icon_AR2";
	doColorShift = false;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	image = AR2Image;
	canDrop = true;
};




datablock ShapeBaseImageData(AR2Image)
{
   shapeFile = "./AR2.dts";
   emap = true;
   
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = AR2Projectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = AR2Item.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";

	stateSound[0]					= activateSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
	stateTimeoutValue[2]            = 0.03;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					=AR2FlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEjectShell[2]       	  = true;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= AR2firesound;
   stateSequence[2]                = "Fire";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.0;
        stateTransitionOnTimeout[3]     = "Reload";



	stateName[4]			= "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.05;
	stateWaitForTimeout[4]		= true;
	stateTransitionOnTimeout[4]     = "Check";
	
	stateName[5]			= "Check";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Ready";
	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.01;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		    = true;

	stateScript[6]                  = "onStopFire";
};

function AR2Image::onFire(%this,%obj,%slot)
{

	

	%projectile = %this.projectile;
	%spread = 0.009;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

schedule(100,0,AR2Zombies);

//### Mount on player

datablock ShapeBaseImageData(AR2BackImage)
{
  shapeFile = "./AR2.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0 -0.35 -0.5";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("45 0 90");
  armReady = false;
  doColorShift = false;
};

function AR2Image::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "AR2BackImage") { %obj.unMountImage(1); }
}

function AR2Image::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(AR2BackImage,1);
}

function AR2Item::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(AR2BackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package AR2Package
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "AR2Item")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "AR2BackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(AR2Package);