//	+-----------------------------------+
//	|		HL2 Weapons Pack			|
//	|		by Zapk & Aware14			|
//	+-----------------------------------+
//	|		MP7.cs						|
//	+-----------------------------------+

//audio
datablock AudioProfile(MP7fireSound)
{
   filename    = "./MP7_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MP7grenadeExplosionSound)
{
   filename    = "./GrenadeExplode.wav";
   description = AudioClose3d;
   preload     = false;
};
datablock AudioProfile(MP7grenadeFireSound)
{
   filename    = "./grenade.wav";
   description = AudioClosest3d;
   preload     = true;
};

datablock ParticleData(MP7grenadeFireParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -1;
   inheritedVelFactor   = 1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";
   spinSpeed		      = 10.0;
   spinRandomMin		   = -150.0;
   spinRandomMax	   	= 150.0;
   colors[0]     = "1 0.5 0 0.4";
   colors[1]     = "1 0.2 0 0.3";
   colors[2]     = "1 0 0 0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.35;
   sizes[2]      = 0.25;
	useInvAlpha = false;
};
datablock ParticleEmitterData(MP7grenadeFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MP7grenadeFireParticle";
};

datablock DebrisData(MP7grenadeDebris)
{
   emitters = "MP7grenadeFireEmitter";

   shapeFile = "base/data/shapes/empty.dts";
   lifetime = 0.8;
   lifetimeVariance = 0.3;
   minSpinSpeed = 0;
   maxSpinSpeed = 1;
   elasticity = 0.3;
   friction = 0.2;
   numBounces = 5;
   staticOnMaxBounce = true;
   fade = true;
   gravModifier = 2;
};

datablock ParticleData(MP7grenadeTrailParticle)
{
   dragCoefficient		= 3.0;
   windCoefficient		= 0.0;
   gravityCoefficient	= 0.0;
   inheritedVelFactor	= 0.0;
   constantAcceleration	= 0.0;
   lifetimeMS		= 600;
   lifetimeVarianceMS	= 0;
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   useInvAlpha		= true;
   animateTexture		= false;
   textureName	= "base/data/particles/thinring";
   colors[0]	= "0.75 0.75 0.75 0.9";
   colors[1]	= "0.75 0.75 0.75 0.4";
   colors[2]	= "1 1 1 0.0";
   sizes[0]	= 0.15;
   sizes[1]	= 0.25;
   sizes[2]	= 0.05;
   times[0]	= 0.0;
   times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(MP7grenadeTrailEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  
   particles = MP7grenadeTrailParticle;
};

datablock ExplosionData(MP7grenadeExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   particleEmitter = MP7grenadeFireEmitter;
   particleDesnity = 300;
   particleRadius = 12;

   debris = MP7grenadeDebris;
   debrisNum = 30;
   debrisNumVariance = 5;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 75;
   debrisVelocityVariance = 10;

   soundProfile = MP7grenadeExplosionSound;


   particleEmitter = rocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = rocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "5.0 5.0 5.0";
   camShakeDuration = 1;
   camShakeRadius = 15;

   lightStartRadius = 100;
   lightEndRadius = 25;
   lightStartColor = "1 1 1";
   lightEndColor = "1 1 1";

   impulseRadius = 16;
   impulseForce = 5000;

   radiusDamage = 160;
   damageRadius = 11;
};

//projectile
AddDamageType("MP7grenadeRadius",'<bitmap:Add-Ons/Weapon_HL2/CI_MP7grenade> %1',    '%2 <bitmap:Add-Ons/Weapon_HL2/CI_MP7grenade> %1',0.5,1);

datablock ProjectileData(MP7grenadeProjectile)
{
   projectileShapeName = "./MP7grenade.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::MP7grenadeRadius;
   radiusDamageType  = $DamageType::MP7grenadeRadius;
   impactImpulse	   = 1500;
   verticalImpulse	  = 100;
   explosion           = MP7grenadeExplosion;
   particleEmitter     = MP7grenadeTrailEmitter;

   brickExplosionRadius = 10;
   brickExplosionImpact = true; 
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 250;
   brickExplosionMaxVolumeFloating = 400;

   muzzleVelocity      = 40;
   velInheritFactor    = 1;

   armingDelay         = 5000;
   lifetime            = 5000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.35;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1;
   explodeOnDeath = true;

   hasLight    = false;
};

AddDamageType("MP7",   '<bitmap:Add-Ons/Weapon_HL2/CI_MP7> %1',    '%2 <bitmap:Add-Ons/Weapon_HL2/CI_MP7> %1',0.5,1);
datablock ProjectileData(MP7Projectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::MP7;
   radiusDamageType    = $DamageType::MP7;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;  
   brickExplosionMaxVolumeFloating = 1; 

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};

datablock ItemData(MP7Item)
{
	category = "Weapon"; 
	className = "Weapon";

	shapeFile = "./MP7.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "MP7";
	iconName = "./Icon_MP7";
	doColorShift = false;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	image = MP7Image;
	canDrop = true;
};




datablock ShapeBaseImageData(MP7Image)
{
   shapeFile = "./MP7.dts";
   emap = true;
   
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = MP7Projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = MP7Item.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";

	stateSound[0]					= activateSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
	stateTimeoutValue[2]            = 0.03;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEjectShell[2]       	  = true;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= MP7firesound;
   stateSequence[2]                = "Fire";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.0;
        stateTransitionOnTimeout[3]     = "Reload";



	stateName[4]			= "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.05;
	stateWaitForTimeout[4]		= true;
	stateTransitionOnTimeout[4]     = "Check";
	
	stateName[5]			= "Check";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Ready";
	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.01;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		    = true;

	stateScript[6]                  = "onStopFire";
};

function MP7Image::onFire(%this,%obj,%slot)
{

	

	%projectile = %this.projectile;
	%spread = 0.014;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}	

schedule(100,0,MP7Zombies);

//### Mount on player

datablock ShapeBaseImageData(MP7BackImage)
{
  shapeFile = "./MP7.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "0 -0.35 -0.65";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("45 0 90");
  armReady = false;
  doColorShift = false;
};

function MP7Image::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "MP7BackImage") { %obj.unMountImage(1); }
}

function MP7Image::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(MP7BackImage,1);
}

function MP7Item::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(MP7BackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package MP7Package
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "MP7Item")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "MP7BackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(MP7Package);

package MP7G
{
   function Armor::onTrigger(%this, %player, %slot, %val)
   {
      if(%player.getMountedImage(0) $= MP7Image.getID() && %slot $= 4 && %val)
      {
         if(%player.lastGrenade !$= "" && getSimTime() - %player.lastGrenade < 30000)
         {
			commandToClient(%player.client, 'CenterPrint', "<color:ffffff><shadow:2:2><shadowcolor:000000>Please wait for the grenade launcher to cool down.", 3);
            return;
         }
         %projectile = MP7GrenadeProjectile;
         %vector = %player.getMuzzleVector(0);
         %objectVelocity = %player.getVelocity();
         %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
         %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
         %velocity = VectorAdd(%vector1,%vector2);
         %p = new Projectile()
         {
            dataBlock = %projectile;
            initialVelocity = %velocity;
            initialPosition = %player.getMuzzlePoint(0);
            sourceObject = %player;
            sourceSlot = 0;
            client = %player.client;
         };
         %player.lastGrenade = getSimTime();
         serverPlay3D(MP7grenadeFireSound,%player.getPosition());
         MissionCleanup.add(%p);
         return %p;
      }
      Parent::onTrigger(%this, %player, %slot, %val);
   }
};   
ActivatePackage(MP7G);	