//	+-----------------------------------+
//	|		HL2 Weapons Pack			|
//	|		by Zapk & Aware14			|
//	+-----------------------------------+
//	|		Stunstick.cs				|
//	+-----------------------------------+

//audio
datablock AudioProfile(StunstickDrawSound)
{
   filename    = "./Stunstick_Draw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(StunstickHitSound)
{
   filename    = "./Stunstick_Hit.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(StunstickSwingSound)
{
   filename    = "./Stunstick_Swing.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(StunstickExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "./bolt";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(StunstickExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "StunstickExplosionParticle";

   uiName = "Stunstick Hit";
};

datablock ExplosionData(StunstickExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = StunstickHitSound;

   particleEmitter = StunstickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};

//Muzzle Electricity stuff
datablock ParticleData(StunstickMuzzleParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0.0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   lifetimeMS           = 10;
   lifetimeVarianceMS   = 10;
   textureName          = "./base/data/particles/cloud";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(StunstickMuzzleEmitter)
{
   ejectionPeriodMS = 0;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "StunstickMuzzleParticle";

   uiName = "Stunstick muzzle";
};


//projectile
AddDamageType("Stunstick",    '<bitmap:Add-Ons/Weapon_HL2/CI_Stunstick> %1',    '%2 <bitmap:Add-Ons/Weapon_HL2/CI_Stunstick> %1',0.5,1);
datablock ProjectileData(StunstickProjectile)
{
   directDamage        = 20;
   directDamageType  = $DamageType::Stunstick;
   radiusDamageType  = $DamageType::Stunstick;
   explosion           = StunstickExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Stunstick bonk";
};


//////////
// item //
//////////
datablock ItemData(StunstickItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Stunstick.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Stunstick";
	iconName = "./Icon_Stunstick";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = StunstickImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(StunstickImage)
{
   // Basic Item properties
   shapeFile = "./Stunstick.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = StunstickItem;
   ammo = " ";
   projectile = StunstickProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Emittercheck";
	stateSound[0]                    = StunstickDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateEmitter[3] 		= Stunstickmuzzleemitter;
	stateEmitterNode[3]		= "muzzlenode";
	stateEmitterTime[3] 		= 0.1;
	stateTransitionOnTimeout[3]     = "checkfire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateSound[3]					= StunstickSwingSound;
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4] = "Fire";
	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Emittercheck";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
	
	StateName[6]			= "Emittercheck";
	stateTransitionOnTimeout[6] 	= "EmitterCheck";
	stateEmitter[6] 		= Stunstickmuzzleemitter;
	stateTimeoutValue[6] 		= 0.1;
	stateTransitionOnTriggerdown[6] = "PreFire";
	stateEmitterTime[6] 		= 0.1;
	stateEmitterNode[6]		= "muzzlenode";

};

function StunstickImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function StunstickImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

package Stunstick
{
function StunstickProjectile::OnCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
	{
		%col.setWhiteOut(1);
   		tumble(%col, 5000);
	}
parent::Oncollision(%this, %obj, %col, %fade, %pos, %normal);
}
};
ActivatePackage(Stunstick);

